/*
 * generated by Fujaba - CodeGen2
 */
package de.uni_kassel.pmss10.mancala;
import de.upb.tools.sdm.*; // requires Fujaba5/libs/RuntimeTools.jar in classpath
import java.util.*;
import de.upb.tools.fca.*; // requires Fujaba5/libs/RuntimeTools.jar in classpath
import de.upb.tools.pcs.PropertyChangeClient; // requires Fujaba5/libs/RuntimeTools.jar in classpath
import java.beans.PropertyChangeSupport;
import java.beans.PropertyChangeListener;


public class Pit	implements PropertyChangeClient
{


	protected final PropertyChangeSupport listeners = new PropertyChangeSupport(this);

	public void addPropertyChangeListener(PropertyChangeListener listener)
	{
		getPropertyChangeSupport().addPropertyChangeListener(listener);
	}

	public void removePropertyChangeListener(PropertyChangeListener listener)
	{
		getPropertyChangeSupport().removePropertyChangeListener(listener);
	}

	public void addPropertyChangeListener(String property, PropertyChangeListener listener)
	{
		getPropertyChangeSupport().addPropertyChangeListener(property, listener);
	}

	public void removePropertyChangeListener(String property, PropertyChangeListener listener)
	{
		getPropertyChangeSupport().removePropertyChangeListener(property, listener);
	}

	public PropertyChangeSupport getPropertyChangeSupport()
	{
		return listeners;
	}


   /**
    * <pre>
    *           0..1     counterpart     0..1
    * Pit ------------------------- Pit
    *           revCounterpart               counterpart
    * </pre>
    */
   public static final String PROPERTY_COUNTERPART = "counterpart";

   private Pit counterpart;

   public boolean setCounterpart (Pit value)
   {
      boolean changed = false;

      if (this.counterpart != value)
      {
      
         Pit oldValue = this.counterpart;
         Pit source = this;
         if (this.counterpart != null)
         {
            this.counterpart = null;
            oldValue.setRevCounterpart (null);
         }
         this.counterpart = value;

         if (value != null)
         {
            value.setRevCounterpart (this);
         }
            getPropertyChangeSupport().firePropertyChange(PROPERTY_COUNTERPART, oldValue, value);
         changed = true;
      
      }
      return changed;
   }

   public Pit withCounterpart (Pit value)
   {
      setCounterpart (value);
      return this;
   }

   public Pit getCounterpart ()
   {
      return this.counterpart;
   }

   /**
    * <pre>
    *           0..1     pit     0..1
    * Pit ------------------------- Mancala
    *           pit               mancala
    * </pre>
    */
   public static final String PROPERTY_MANCALA = "mancala";

   private Mancala mancala;

   public boolean setMancala (Mancala value)
   {
      boolean changed = false;

      if (this.mancala != value)
      {
      
         Mancala oldValue = this.mancala;
         Pit source = this;
         if (this.mancala != null)
         {
            this.mancala = null;
            oldValue.removeFromPit (this);
         }
         this.mancala = value;

         if (value != null)
         {
            value.addToPit (this);
         }
            getPropertyChangeSupport().firePropertyChange(PROPERTY_MANCALA, oldValue, value);
         changed = true;
      
      }
      return changed;
   }

   public Pit withMancala (Mancala value)
   {
      setMancala (value);
      return this;
   }

   public Mancala getMancala ()
   {
      return this.mancala;
   }

   public void moveStones ()
   {
      boolean fujaba__Success = false;
      Player player = null;
      Iterator fujaba__IterThisToStone = null;
      Stone stone = null;
      Pit nextPit = null;
      Pit previousPit = null;
      Kalah kalah = null;
      boolean changeActive = false;
      Player otherPlayer = null;
      Pit counterpartPit = null;
      Iterator fujaba__IterOtherPlayerPitToSomeStone = null;
      Stone someStone = null;
      Iterator fujaba__IterOtherPlayerToOtherPlayerPit = null;
      Pit otherPlayerPit = null;
      Iterator fujaba__IterCounterpartPitToCounterpartStone = null;
      Stone counterpartStone = null;
      Iterator fujaba__IterMancalaToSecondPlayer = null;
      Player secondPlayer = null;

      // // Check if the player is active
      // story pattern storypatternwiththis
      try 
      {
         fujaba__Success = false; 

         // search to-one link pits from this to player
         player = this.getPlayer ();

         // check object player is really bound
         JavaSDM.ensure ( player != null );

         // check link activePlayer from mancala to player
         JavaSDM.ensure (player.equals (mancala.getActivePlayer ()));


         fujaba__Success = true;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      if ( !( fujaba__Success ) )
      {
         return ;

      }
      // // Move stones
      // story pattern storypatternwiththis
      try 
      {
         fujaba__Success = false; 

         // search to-one link next from this to nextPit
         nextPit = this.getNext ();

         // check object nextPit is really bound
         JavaSDM.ensure ( nextPit != null );

         // check isomorphic binding between objects this and nextPit
         JavaSDM.ensure ( !this.equals (nextPit) );

         // iterate to-many link stones from this to stone
         fujaba__Success = false;
         fujaba__IterThisToStone = this.iteratorOfStones ();

         while ( fujaba__IterThisToStone.hasNext () )
         {
            try
            {
               stone = (Stone) fujaba__IterThisToStone.next ();

               // check object stone is really bound
               JavaSDM.ensure ( stone != null );
               // create link stones from stone to nextPit
               stone.setPit (nextPit);

               // collabStat call
               nextPit = nextPit.getNext();

               fujaba__Success = true;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false;
            }
         }
         JavaSDM.ensure (fujaba__Success);

         fujaba__Success = true;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      // // Check if the last stone fall into an empty pit of the current player
      // story pattern successor
      try 
      {
         fujaba__Success = false; 

         // check object nextPit is really bound
         JavaSDM.ensure ( nextPit != null );
         // check object player is really bound
         JavaSDM.ensure ( player != null );
         // search to-one link kalah from player to kalah
         kalah = player.getKalah ();

         // check object kalah is really bound
         JavaSDM.ensure ( kalah != null );

         // check isomorphic binding between objects nextPit and kalah
         JavaSDM.ensure ( !nextPit.equals (kalah) );

         // search to-one link next from nextPit to previousPit
         previousPit = nextPit.getPrevious ();

         // check object previousPit is really bound
         JavaSDM.ensure ( previousPit != null );

         // check isomorphic binding between objects previousPit and kalah
         JavaSDM.ensure ( !previousPit.equals (kalah) );

         // check isomorphic binding between objects previousPit and nextPit
         JavaSDM.ensure ( !previousPit.equals (nextPit) );

         // check link pits from previousPit to player
         JavaSDM.ensure (player.equals (previousPit.getPlayer ()));

         // constraint previousPit.sizeOfStones() == 1
         JavaSDM.ensure ( previousPit.sizeOfStones() == 1 );


         // collabStat call
         changeActive = false;
         fujaba__Success = true;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      if ( fujaba__Success )
      {
         // // Check if we can capture stones -> find counterpart
         // story pattern successor
         try 
         {
            fujaba__Success = false; 

            // check object player is really bound
            JavaSDM.ensure ( player != null );
            // check object previousPit is really bound
            JavaSDM.ensure ( previousPit != null );
            // search to-one link counterpart from previousPit to counterpartPit
            counterpartPit = previousPit.getCounterpart ();

            // check object counterpartPit is really bound
            JavaSDM.ensure ( counterpartPit != null );

            // check isomorphic binding between objects previousPit and counterpartPit
            JavaSDM.ensure ( !previousPit.equals (counterpartPit) );

            // search to-one link pits from counterpartPit to otherPlayer
            otherPlayer = counterpartPit.getPlayer ();

            // check object otherPlayer is really bound
            JavaSDM.ensure ( otherPlayer != null );

            // check isomorphic binding between objects player and otherPlayer
            JavaSDM.ensure ( !player.equals (otherPlayer) );



            fujaba__Success = true;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false;
         }

         if ( fujaba__Success )
         {
            // // Check that the counterpart stones are not the last ones
            // story pattern successor
            try 
            {
               fujaba__Success = false; 

               // check object counterpartPit is really bound
               JavaSDM.ensure ( counterpartPit != null );
               // check object otherPlayer is really bound
               JavaSDM.ensure ( otherPlayer != null );
               // iterate to-many link pits from otherPlayer to otherPlayerPit
               fujaba__Success = false;
               fujaba__IterOtherPlayerToOtherPlayerPit = otherPlayer.iteratorOfPits ();

               while ( !(fujaba__Success) && fujaba__IterOtherPlayerToOtherPlayerPit.hasNext () )
               {
                  try
                  {
                     otherPlayerPit = (Pit) fujaba__IterOtherPlayerToOtherPlayerPit.next ();

                     // check object otherPlayerPit is really bound
                     JavaSDM.ensure ( otherPlayerPit != null );
                     // check isomorphic binding between objects otherPlayerPit and counterpartPit
                     JavaSDM.ensure ( !otherPlayerPit.equals (counterpartPit) );

                     // iterate to-many link stones from otherPlayerPit to someStone
                     fujaba__Success = false;
                     fujaba__IterOtherPlayerPitToSomeStone = otherPlayerPit.iteratorOfStones ();

                     while ( !(fujaba__Success) && fujaba__IterOtherPlayerPitToSomeStone.hasNext () )
                     {
                        try
                        {
                           someStone = (Stone) fujaba__IterOtherPlayerPitToSomeStone.next ();

                           // check object someStone is really bound
                           JavaSDM.ensure ( someStone != null );

                           fujaba__Success = true;
                        }
                        catch ( JavaSDMException fujaba__InternalException )
                        {
                           fujaba__Success = false;
                        }
                     }
                     JavaSDM.ensure (fujaba__Success);

                     fujaba__Success = true;
                  }
                  catch ( JavaSDMException fujaba__InternalException )
                  {
                     fujaba__Success = false;
                  }
               }
               JavaSDM.ensure (fujaba__Success);
               fujaba__Success = true;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false;
            }

            if ( fujaba__Success )
            {
               // // For each stone in the counterpartPit
               // story pattern successor
               try 
               {
                  fujaba__Success = false; 

                  // check object counterpartPit is really bound
                  JavaSDM.ensure ( counterpartPit != null );
                  // iterate to-many link stones from counterpartPit to counterpartStone
                  fujaba__Success = false;
                  fujaba__IterCounterpartPitToCounterpartStone = counterpartPit.iteratorOfStones ();

                  while ( fujaba__IterCounterpartPitToCounterpartStone.hasNext () )
                  {
                     try
                     {
                        counterpartStone = (Stone) fujaba__IterCounterpartPitToCounterpartStone.next ();

                        // check object counterpartStone is really bound
                        JavaSDM.ensure ( counterpartStone != null );
                        // // Put it into the players kalah
                        // story pattern successor
                        try 
                        {
                           fujaba__Success = false; 

                           // check object counterpartStone is really bound
                           JavaSDM.ensure ( counterpartStone != null );
                           // check object kalah is really bound
                           JavaSDM.ensure ( kalah != null );
                           // create link stones from kalah to counterpartStone
                           kalah.addToStones (counterpartStone);

                           fujaba__Success = true;
                        }
                        catch ( JavaSDMException fujaba__InternalException )
                        {
                           fujaba__Success = false;
                        }


                        fujaba__Success = true;
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                        fujaba__Success = false;
                     }
                  }
                  JavaSDM.ensure (fujaba__Success);
                  fujaba__Success = true;
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
                  fujaba__Success = false;
               }

               // story pattern successor
               try 
               {
                  fujaba__Success = false; 

                  // check object kalah is really bound
                  JavaSDM.ensure ( kalah != null );
                  // check object stone is really bound
                  JavaSDM.ensure ( stone != null );
                  // create link stones from stone to kalah
                  stone.setPit (kalah);

                  // collabStat call
                  changeActive = true;
                  fujaba__Success = true;
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
                  fujaba__Success = false;
               }


            }

         }

      }
      else
      {
         // story pattern successor
         try 
         {
            fujaba__Success = false; 

            // collabStat call
            changeActive = true;
            fujaba__Success = true;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false;
         }


      }
      // // set active player
      // story pattern set actiuve player
      try 
      {
         fujaba__Success = false; 

         // check object mancala is really bound
         JavaSDM.ensure ( mancala != null );
         // check object player is really bound
         JavaSDM.ensure ( player != null );
         // check link activePlayer from mancala to player
         JavaSDM.ensure (player.equals (mancala.getActivePlayer ()));

         // iterate to-many link player from mancala to secondPlayer
         fujaba__Success = false;
         fujaba__IterMancalaToSecondPlayer = mancala.iteratorOfPlayer ();

         while ( !(fujaba__Success) && fujaba__IterMancalaToSecondPlayer.hasNext () )
         {
            try
            {
               secondPlayer = (Player) fujaba__IterMancalaToSecondPlayer.next ();

               // check object secondPlayer is really bound
               JavaSDM.ensure ( secondPlayer != null );
               // check isomorphic binding between objects secondPlayer and player
               JavaSDM.ensure ( !secondPlayer.equals (player) );

               // constraint changeActive
               JavaSDM.ensure ( changeActive );

               fujaba__Success = true;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false;
            }
         }
         JavaSDM.ensure (fujaba__Success);
         // destroy link activePlayer from mancala to player
         mancala.setActivePlayer (null);
         // create link activePlayer from mancala to secondPlayer
         mancala.setActivePlayer (secondPlayer);

         fujaba__Success = true;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      // story pattern check end
      try 
      {
         fujaba__Success = false; 

         // check object mancala is really bound
         JavaSDM.ensure ( mancala != null );
         // collabStat call
         mancala.checkEnd();
         fujaba__Success = true;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      return ;
   }

   /**
    * <pre>
    *           0..1     next     0..1
    * Pit ------------------------- Pit
    *           previous               next
    * </pre>
    */
   public static final String PROPERTY_NEXT = "next";

   private Pit next;

   public boolean setNext (Pit value)
   {
      boolean changed = false;

      if (this.next != value)
      {
      
         Pit oldValue = this.next;
         Pit source = this;
         if (this.next != null)
         {
            this.next = null;
            oldValue.setPrevious (null);
         }
         this.next = value;

         if (value != null)
         {
            value.setPrevious (this);
         }
            getPropertyChangeSupport().firePropertyChange(PROPERTY_NEXT, oldValue, value);
         changed = true;
      
      }
      return changed;
   }

   public Pit withNext (Pit value)
   {
      setNext (value);
      return this;
   }

   public Pit getNext ()
   {
      return this.next;
   }

   public static final String PROPERTY_NR = "nr";

   private int nr;

   public void setNr (int value)
   {
      if ( this.nr != value )
      {
         int oldValue = this.nr;
         this.nr = value;
         getPropertyChangeSupport().firePropertyChange(PROPERTY_NR, oldValue, value);
      }
   }

   public Pit withNr (int value)
   {
      setNr (value);
      return this;
   }

   public int getNr ()
   {
      return this.nr;
   }

   /**
    * <pre>
    *           0..n     pits     0..1
    * Pit ------------------------- Player
    *           pits               player
    * </pre>
    */
   public static final String PROPERTY_PLAYER = "player";

   private Player player;

   public boolean setPlayer (Player value)
   {
      boolean changed = false;

      if (this.player != value)
      {
      
         Player oldValue = this.player;
         Pit source = this;
         if (this.player != null)
         {
            this.player = null;
            oldValue.removeFromPits (this);
         }
         this.player = value;

         if (value != null)
         {
            value.addToPits (this);
         }
            getPropertyChangeSupport().firePropertyChange(PROPERTY_PLAYER, oldValue, value);
         changed = true;
      
      }
      return changed;
   }

   public Pit withPlayer (Player value)
   {
      setPlayer (value);
      return this;
   }

   public Player getPlayer ()
   {
      return this.player;
   }

   /**
    * <pre>
    *           0..1     next     0..1
    * Pit ------------------------- Pit
    *           next               previous
    * </pre>
    */
   public static final String PROPERTY_PREVIOUS = "previous";

   private Pit previous;

   public boolean setPrevious (Pit value)
   {
      boolean changed = false;

      if (this.previous != value)
      {
      
         Pit oldValue = this.previous;
         Pit source = this;
         if (this.previous != null)
         {
            this.previous = null;
            oldValue.setNext (null);
         }
         this.previous = value;

         if (value != null)
         {
            value.setNext (this);
         }
            getPropertyChangeSupport().firePropertyChange(PROPERTY_PREVIOUS, oldValue, value);
         changed = true;
      
      }
      return changed;
   }

   public Pit withPrevious (Pit value)
   {
      setPrevious (value);
      return this;
   }

   public Pit getPrevious ()
   {
      return this.previous;
   }

   /**
    * <pre>
    *           0..1     counterpart     0..1
    * Pit ------------------------- Pit
    *           counterpart               revCounterpart
    * </pre>
    */
   public static final String PROPERTY_REV_COUNTERPART = "revCounterpart";

   private Pit revCounterpart;

   public boolean setRevCounterpart (Pit value)
   {
      boolean changed = false;

      if (this.revCounterpart != value)
      {
      
         Pit oldValue = this.revCounterpart;
         Pit source = this;
         if (this.revCounterpart != null)
         {
            this.revCounterpart = null;
            oldValue.setCounterpart (null);
         }
         this.revCounterpart = value;

         if (value != null)
         {
            value.setCounterpart (this);
         }
            getPropertyChangeSupport().firePropertyChange(PROPERTY_REV_COUNTERPART, oldValue, value);
         changed = true;
      
      }
      return changed;
   }

   public Pit withRevCounterpart (Pit value)
   {
      setRevCounterpart (value);
      return this;
   }

   public Pit getRevCounterpart ()
   {
      return this.revCounterpart;
   }

   /**
    * <pre>
    *           0..1     stones     0..n
    * Pit ------------------------- Stone
    *           pit               stones
    * </pre>
    */
   public static final String PROPERTY_STONES = "stones";

   private FPropHashSet<Stone> stones;

   public Set<? extends Stone> getStones()
   {
      return ((this.stones == null)
              ? Collections.EMPTY_SET
              : Collections.unmodifiableSet(this.stones));
   }

   public boolean addToStones (Stone value)
   {
      boolean changed = false;

      if (value != null)
      {
         if (this.stones == null)
         {
            this.stones = new FPropHashSet<Stone> (this, PROPERTY_STONES);

         }
      
         changed = this.stones.add (value);
         if (changed)
         {
            value.setPit (this);
         }
      
      }
      return changed;
   }

   public Pit withStones (Stone value)
   {
      addToStones (value);
      return this;
   }

   public Pit withoutStones (Stone value)
   {
      removeFromStones (value);
      return this;
   }


   public boolean removeFromStones (Stone value)
   {
      boolean changed = false;

      if ((this.stones != null) && (value != null))
      {
      
         changed = this.stones.remove (value);
         if (changed)
         {
            value.setPit (null);
         }
      
      }
      return changed;
   }

   public void removeAllFromStones (){
   
      Stone tmpValue;
      Iterator<? extends Stone> iter = this.iteratorOfStones ();
      while (iter.hasNext ())
      {
         tmpValue = (Stone) iter.next ();
         this.removeFromStones (tmpValue);
      }
   
   }

   public boolean hasInStones (Stone value)
   {
      return ((this.stones != null) &&
              (value != null) &&
              this.stones.contains (value));
   }

   public Iterator<? extends Stone> iteratorOfStones ()
   {
      return ((this.stones == null)
              ? FEmptyIterator.<Stone>get ()
              : this.stones.iterator ());
   }

   public int sizeOfStones ()
   {
      return ((this.stones == null)
              ? 0
              : this.stones.size ());
   }

   public void removeYou()
   {
      this.setCounterpart (null);
      this.setMancala (null);
      this.setNext (null);
      this.setPlayer (null);
      this.setPrevious (null);
      this.setRevCounterpart (null);
      this.removeAllFromStones ();
   }
}


