/*
 * generated by Fujaba - CodeGen2
 */
package de.uni_kassel.pmss10.mancala;
import de.upb.tools.sdm.*; // requires Fujaba5/libs/RuntimeTools.jar in classpath
import java.util.*;
import de.upb.tools.fca.*; // requires Fujaba5/libs/RuntimeTools.jar in classpath
import de.upb.tools.pcs.PropertyChangeClient; // requires Fujaba5/libs/RuntimeTools.jar in classpath
import java.beans.PropertyChangeSupport;
import java.beans.PropertyChangeListener;


public class Player	implements PropertyChangeClient
{


	protected final PropertyChangeSupport listeners = new PropertyChangeSupport(this);

	public void addPropertyChangeListener(PropertyChangeListener listener)
	{
		getPropertyChangeSupport().addPropertyChangeListener(listener);
	}

	public void removePropertyChangeListener(PropertyChangeListener listener)
	{
		getPropertyChangeSupport().removePropertyChangeListener(listener);
	}

	public void addPropertyChangeListener(String property, PropertyChangeListener listener)
	{
		getPropertyChangeSupport().addPropertyChangeListener(property, listener);
	}

	public void removePropertyChangeListener(String property, PropertyChangeListener listener)
	{
		getPropertyChangeSupport().removePropertyChangeListener(property, listener);
	}

	public PropertyChangeSupport getPropertyChangeSupport()
	{
		return listeners;
	}


   /**
    * <pre>
    *           0..1     kalah     0..1
    * Player ------------------------- Kalah
    *           kalahPlayer               kalah
    * </pre>
    */
   public static final String PROPERTY_KALAH = "kalah";

   private Kalah kalah;

   public boolean setKalah (Kalah value)
   {
      boolean changed = false;

      if (this.kalah != value)
      {
      
         Kalah oldValue = this.kalah;
         Player source = this;
         if (this.kalah != null)
         {
            this.kalah = null;
            oldValue.setKalahPlayer (null);
         }
         this.kalah = value;

         if (value != null)
         {
            value.setKalahPlayer (this);
         }
            getPropertyChangeSupport().firePropertyChange(PROPERTY_KALAH, oldValue, value);
         changed = true;
      
      }
      return changed;
   }

   public Player withKalah (Kalah value)
   {
      setKalah (value);
      return this;
   }

   public Kalah getKalah ()
   {
      return this.kalah;
   }

   /**
    * <pre>
    *           0..n     player     0..1
    * Player ------------------------- Mancala
    *           player               mancala
    * </pre>
    */
   public static final String PROPERTY_MANCALA = "mancala";

   private Mancala mancala;

   public boolean setMancala (Mancala value)
   {
      boolean changed = false;

      if (this.mancala != value)
      {
      
         Mancala oldValue = this.mancala;
         Player source = this;
         if (this.mancala != null)
         {
            this.mancala = null;
            oldValue.removeFromPlayer (this);
         }
         this.mancala = value;

         if (value != null)
         {
            value.addToPlayer (this);
         }
            getPropertyChangeSupport().firePropertyChange(PROPERTY_MANCALA, oldValue, value);
         changed = true;
      
      }
      return changed;
   }

   public Player withMancala (Mancala value)
   {
      setMancala (value);
      return this;
   }

   public Mancala getMancala ()
   {
      return this.mancala;
   }

   public void moveAllStonesToKalah ()
   {
      boolean fujaba__Success = false;
      Kalah kalah = null;
      Iterator fujaba__IterPitToStone = null;
      Stone stone = null;
      Iterator fujaba__IterThisToPit = null;
      Pit pit = null;

      // story pattern storypatternwiththis
      try 
      {
         fujaba__Success = false; 

         // search to-one link kalah from this to kalah
         kalah = this.getKalah ();

         // check object kalah is really bound
         JavaSDM.ensure ( kalah != null );


         fujaba__Success = true;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      // story pattern storypatternwiththis
      try 
      {
         fujaba__Success = false; 

         // iterate to-many link pits from this to pit
         fujaba__Success = false;
         fujaba__IterThisToPit = this.iteratorOfPits ();

         while ( fujaba__IterThisToPit.hasNext () )
         {
            try
            {
               pit = (Pit) fujaba__IterThisToPit.next ();

               // check object pit is really bound
               JavaSDM.ensure ( pit != null );
               // story pattern Successor of storypatternwiththis
               try 
               {
                  fujaba__Success = false; 

                  // check object pit is really bound
                  JavaSDM.ensure ( pit != null );
                  // iterate to-many link stones from pit to stone
                  fujaba__Success = false;
                  fujaba__IterPitToStone = pit.iteratorOfStones ();

                  while ( fujaba__IterPitToStone.hasNext () )
                  {
                     try
                     {
                        stone = (Stone) fujaba__IterPitToStone.next ();

                        // check object stone is really bound
                        JavaSDM.ensure ( stone != null );
                        // story pattern Successor of Successor of storypatternwiththis
                        try 
                        {
                           fujaba__Success = false; 

                           // check object kalah is really bound
                           JavaSDM.ensure ( kalah != null );
                           // check object stone is really bound
                           JavaSDM.ensure ( stone != null );
                           // create link stones from kalah to stone
                           kalah.addToStones (stone);

                           fujaba__Success = true;
                        }
                        catch ( JavaSDMException fujaba__InternalException )
                        {
                           fujaba__Success = false;
                        }


                        fujaba__Success = true;
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                        fujaba__Success = false;
                     }
                  }
                  JavaSDM.ensure (fujaba__Success);
                  fujaba__Success = true;
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
                  fujaba__Success = false;
               }


               fujaba__Success = true;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false;
            }
         }
         JavaSDM.ensure (fujaba__Success);
         fujaba__Success = true;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      return ;
   }

   public static final String PROPERTY_NAME = "name";

   private String name;

   public void setName (String value)
   {
      if ( ! JavaSDM.stringEquals (this.name, value))
      {
         String oldValue = this.name;
         this.name = value;
         getPropertyChangeSupport().firePropertyChange(PROPERTY_NAME, oldValue, value);
      }
   }

   public Player withName (String value)
   {
      setName (value);
      return this;
   }

   public String getName ()
   {
      return this.name;
   }

   /**
    * <pre>
    *           0..1     pits     0..n
    * Player ------------------------- Pit
    *           player               pits
    * </pre>
    */
   public static final String PROPERTY_PITS = "pits";

   private FPropHashSet<Pit> pits;

   public Set<? extends Pit> getPits()
   {
      return ((this.pits == null)
              ? Collections.EMPTY_SET
              : Collections.unmodifiableSet(this.pits));
   }

   public boolean addToPits (Pit value)
   {
      boolean changed = false;

      if (value != null)
      {
         if (this.pits == null)
         {
            this.pits = new FPropHashSet<Pit> (this, PROPERTY_PITS);

         }
      
         changed = this.pits.add (value);
         if (changed)
         {
            value.setPlayer (this);
         }
      
      }
      return changed;
   }

   public Player withPits (Pit value)
   {
      addToPits (value);
      return this;
   }

   public Player withoutPits (Pit value)
   {
      removeFromPits (value);
      return this;
   }


   public boolean removeFromPits (Pit value)
   {
      boolean changed = false;

      if ((this.pits != null) && (value != null))
      {
      
         changed = this.pits.remove (value);
         if (changed)
         {
            value.setPlayer (null);
         }
      
      }
      return changed;
   }

   public void removeAllFromPits (){
   
      Pit tmpValue;
      Iterator<? extends Pit> iter = this.iteratorOfPits ();
      while (iter.hasNext ())
      {
         tmpValue = (Pit) iter.next ();
         this.removeFromPits (tmpValue);
      }
   
   }

   public boolean hasInPits (Pit value)
   {
      return ((this.pits != null) &&
              (value != null) &&
              this.pits.contains (value));
   }

   public Iterator<? extends Pit> iteratorOfPits ()
   {
      return ((this.pits == null)
              ? FEmptyIterator.<Pit>get ()
              : this.pits.iterator ());
   }

   public int sizeOfPits ()
   {
      return ((this.pits == null)
              ? 0
              : this.pits.size ());
   }

   public void removeYou()
   {
      this.setKalah (null);
      this.setMancala (null);
      this.removeAllFromPits ();
   }
}


