package de.uni_kassel.pmss10.mancala.gui;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

public class LoginScreen extends JFrame
{
   private JTextField playerOneTextField;
   private JTextField playerTwoTextField;
   private JButton goButton;
   private JButton quitButton;


   public LoginScreen()
   {
      super("Mancala");
      
      // Create the background
      JPanel background = new BackgroundPanel("images/MancalaBackground.jpg");
      background.setBorder(BorderFactory.createEmptyBorder(20, 20, 20, 20));
      background.setLayout(new GridBagLayout());
      
      // Add the background
      getContentPane().add(background, BorderLayout.CENTER);
      
      // Create the content
      createContent(background);
      
      // Set size 
      setSize(500, 350);
      
      // Center frame
      setLocationRelativeTo(null);
      
      // Close on exit
      setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
      
      // Show it
      setVisible(true);
      
   }
   

   private void createContent(JPanel parent)
   {
      GridBagConstraints c = new GridBagConstraints();
      c.gridy = 0;
      c.weightx = 1;
      c.insets = new Insets(0, 0, 20, 0);
      parent.add(new JLabel("<html><font size=+2>Mancala</font></html>"),c);
      
      
      JPanel holder = new JPanel(new FlowLayout());
      holder.setOpaque(false);
      holder.add(new JLabel("Player 1:"));
      playerOneTextField = new JTextField(15);
      holder.add(playerOneTextField);
      
      c.gridy = 1;
      c.insets = new Insets(0, 0, 0, 0);
      parent.add(holder,c);
      
      holder = new JPanel(new FlowLayout());
      holder.setOpaque(false);
      holder.add(new JLabel("Player 2:"));
      playerTwoTextField = new JTextField(15);
      holder.add(playerTwoTextField);
      
      c.gridy = 2;
      parent.add(holder,c);
      
      goButton = new JButton("Go");
      
      c.gridy = 3;
      c.insets = new Insets(20, 0, 50, 0);
      parent.add(goButton,c);
      
      holder = new JPanel(new FlowLayout());
      quitButton = new JButton("Quit");
//      holder.add(quitButton);
      
      c.fill = GridBagConstraints.NONE;
      c.gridy = 4;
      c.weighty = 1;
      c.insets = new Insets(0, 0, 0, 0);
      c.anchor = GridBagConstraints.LAST_LINE_START;
      parent.add(quitButton,c);
   }


   public JTextField getPlayerOneTextField()
   {
      return playerOneTextField;
   }


   public JTextField getPlayerTwoTextField()
   {
      return playerTwoTextField;
   }


   public JButton getGoButton()
   {
      return goButton;
   }


   public JButton getQuitButton()
   {
      return quitButton;
   }
   
   
}
